SystemOrganization addCategory: #'Tiny-Blog'!
SystemOrganization addCategory: 'Tiny-Blog-Tests'!

TestCase subclass: #TBBlogTest
	instanceVariableNames: 'blog post first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tiny-Blog-Tests'!

!TBBlogTest commentStamp: '<historical>' prior: 0!
Test cases for TBBlog!

Object subclass: #TBBlog
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tiny-Blog'!

TBBlog class
	instanceVariableNames: 'uniqueInstance'!

!TBBlog commentStamp: '<historical>' prior: 0!
Class TBBlog

have:

 -posts!

TBBlog class
	instanceVariableNames: 'uniqueInstance'!

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'ManuelCastro 11/12/2017 15:16'!
current
	"ans the instance of the TBRepository"
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'ManuelCastro 11/12/2017 15:16'!
initialize
	self reset! !

TBBlog initialize!

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'ManuelCastro 11/12/2017 15:15'!
reset
	uniqueInstance := nil! !

!TBBlog methodsFor: 'action' stamp: 'ManuelCastro 11/12/2017 15:52'!
allBlogPosts
	^ posts! !

!TBBlog methodsFor: 'action' stamp: 'ManuelCastro 11/12/2017 15:59'!
allBlogPostsFromCategory: aCategory 
	^ posts select: [ :p | p category = aCategory ]! !

!TBBlog methodsFor: 'action' stamp: 'ManuelCastro 11/12/2017 16:09'!
allCategories
	^ (self allBlogPosts collect: [ :p | p category]) asSet! !

!TBBlog methodsFor: 'actions' stamp: 'ManuelCastro 11/12/2017 15:55'!
allVisibleBlogPosts
	^ posts select: [ : p | p isVisible ]! !

!TBBlog methodsFor: 'action' stamp: 'ManuelCastro 11/12/2017 16:05'!
allVisibleBlogPostsFromCategory: aCategory
	^ posts select: [ :p | p category = aCategory and: [ p isVisible ] ]! !

!TBBlog methodsFor: 'initialization' stamp: 'ManuelCastro 11/12/2017 15:13'!
initialize
	super initialize.
	posts := OrderedCollection new! !

!TBBlog methodsFor: 'remove' stamp: 'ManuelCastro 11/12/2017 15:38'!
removeAllPosts
	posts := OrderedCollection new! !

!TBBlog methodsFor: 'sizes' stamp: 'ManuelCastro 11/12/2017 15:47'!
size
	^ posts size! !

!TBBlog methodsFor: 'adding item' stamp: 'ManuelCastro 11/12/2017 15:42'!
writeBlogPost: aTBPost 
	"add a post in database"
	posts add: aTBPost! !

Object subclass: #TBPost
	instanceVariableNames: 'title text date category visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tiny-Blog'!

!TBPost commentStamp: '<historical>' prior: 0!
There is a TinyBlog post

variables:
	title
	text
	date
	category
	visible!

!TBPost class methodsFor: 'as yet unclassified' stamp: 'ManuelCastro 11/10/2017 14:51'!
title: aTitle text: aText
	^ self new
		title: aTitle;
		text: aText;
		yourself! !

!TBPost class methodsFor: 'as yet unclassified' stamp: 'ManuelCastro 11/10/2017 14:52'!
title: aTitle text: aText category: aCategory
	^ (self title: aTitle text: aText)
		category: aCategory;
		yourself! !

!TBPost class methodsFor: 'as yet unclassified' stamp: 'ManuelCastro 11/10/2017 14:46'!
unclassifiedTag
	^ 'Unclassified'! !

!TBPost methodsFor: 'action' stamp: 'ManuelCastro 11/10/2017 14:40'!
beVisible
	self visible: true! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:39'!
category
	^ category! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:39'!
category: anObject
	category := anObject ! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:37'!
date
	^ date! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:37'!
date: aDate
	date := aDate! !

!TBPost methodsFor: 'initialization' stamp: 'ManuelCastro 11/10/2017 14:45'!
initialize
	self category: TBPost unclassifiedTag.
	self date: Date today.
	self notVisible ! !

!TBPost methodsFor: 'action' stamp: 'ManuelCastro 11/10/2017 14:55'!
isUnclassified
	^ self category = TBPost unclassifiedTag ! !

!TBPost methodsFor: 'action' stamp: 'ManuelCastro 11/10/2017 14:41'!
isVisible
	^ self visible! !

!TBPost methodsFor: 'action' stamp: 'ManuelCastro 11/10/2017 14:41'!
notVisible
	self visible: false! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:36'!
text
	^ text! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:37'!
text: aString
	text := aString! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:36'!
title
	^ title! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:36'!
title: aString
	title := aString! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:38'!
visible
	^ visible! !

!TBPost methodsFor: 'accesing' stamp: 'ManuelCastro 11/10/2017 14:38'!
visible: aBoolean
	visible := aBoolean! !

TBBlog initialize!
